package com.ejie.ab63.model.pagos;

import java.math.BigDecimal;
import java.util.Date;

import com.ejie.ab63.util.UtilDate;
import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * PagosExpediente  
 * 
 *  
 */

public class PagosExpediente implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idPagoExpediente;
	// private Expedientes expediente;
	private Integer idExpediente;
	private Long numeroPago;
	private BigDecimal porcentajePago;
	private BigDecimal importePago;
	private Long anyoPresupuestario;
	private String observaciones;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private Date fechaUltmodificacion;
	private String usuarioUltmodificacion;
	private Date fechaPago;
	private Date fechaEnvSer;
	private Date fechaDocPag;

	private String fechaPagoStr;
	private String fechaEnvSerStr;
	private String fechaDocPagStr;

	/**
	 * Method 'PagosExpediente'.
	 */
	public PagosExpediente() {
	}

	/**
	 * Method 'PagosExpediente'.
	 * 
	 * @param idPagoExpediente
	 *            Integer
	 */
	public PagosExpediente(Integer idPagoExpediente) {
		this.idPagoExpediente = idPagoExpediente;
	}

	/**
	 * Method 'PagosExpediente'.
	 * 
	 * @param idPagoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param numeroPago
	 *            Long
	 * @param porcentajePago
	 *            BigDecimal
	 * @param importePago
	 *            BigDecimal
	 * @param anyoPresupuestario
	 *            Long
	 * @param observaciones
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param fechaPago
	 *            Date
	 * @param fechaEnvSer
	 *            Date
	 * @param fechaDocPag
	 *            Date
	 * 
	 */
	public PagosExpediente(Integer idPagoExpediente, Integer idExpediente, Long numeroPago, BigDecimal porcentajePago,
			BigDecimal importePago, Long anyoPresupuestario, String observaciones, Date fechaRegistro,
			String usuarioRegistro, Date fechaUltmodificacion, String usuarioUltmodificacion, Date fechaPago,
			Date fechaEnvSer, Date fechaDocPag) {

		this.idPagoExpediente = idPagoExpediente;
		this.idExpediente = idExpediente;
		this.numeroPago = numeroPago;
		this.porcentajePago = porcentajePago;
		this.importePago = importePago;
		this.anyoPresupuestario = anyoPresupuestario;
		this.observaciones = observaciones;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.fechaPago = fechaPago;
		this.fechaEnvSer = fechaEnvSer;
		this.fechaDocPag = fechaDocPag;
	}

	/**
	 * Method 'PagosExpediente'.
	 * 
	 * @param idPagoExpediente
	 *            Integer
	 * @param idExpediente
	 *            Integer
	 * @param numeroPago
	 *            Long
	 * @param porcentajePago
	 *            BigDecimal
	 * @param importePago
	 *            BigDecimal
	 * @param anyoPresupuestario
	 *            Long
	 * @param observaciones
	 *            String
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param fechaUltmodificacion
	 *            Date
	 * @param usuarioUltmodificacion
	 *            String
	 * @param fechaPago
	 *            Date
	 * @param fechaEnvSer
	 *            Date
	 * @param fechaDocPag
	 *            Date
	 * 
	 */
	public PagosExpediente(Long numeroPago, BigDecimal porcentajePago, BigDecimal importePago, Long anyoPresupuestario,
			String observaciones, Date fechaRegistro, String usuarioRegistro, Date fechaUltmodificacion,
			String usuarioUltmodificacion, Date fechaPago, Date fechaEnvSer, Date fechaDocPag) {

		this.numeroPago = numeroPago;
		this.porcentajePago = porcentajePago;
		this.importePago = importePago;
		this.anyoPresupuestario = anyoPresupuestario;
		this.observaciones = observaciones;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.fechaUltmodificacion = fechaUltmodificacion;
		this.usuarioUltmodificacion = usuarioUltmodificacion;
		this.fechaPago = fechaPago;
		this.fechaEnvSer = fechaEnvSer;
		this.fechaDocPag = fechaDocPag;
	}

	/*
	 * public PagosExpediente(Integer idPagoExpediente, Expedientes expediente,
	 * Long numeroPago, BigDecimal porcentajePago, BigDecimal importePago, Long
	 * anyoPresupuestario, String observaciones, Date fechaRegistro, String
	 * usuarioRegistro, Date fechaUltmodificacion, String
	 * usuarioUltmodificacion, Date fechaPago, Date fechaEnvSer, Date
	 * fechaDocPag) {
	 * 
	 * this.idPagoExpediente = idPagoExpediente; this.expediente = expediente;
	 * this.numeroPago = numeroPago; this.porcentajePago = porcentajePago;
	 * this.importePago = importePago; this.anyoPresupuestario =
	 * anyoPresupuestario; this.observaciones = observaciones;
	 * this.fechaRegistro = fechaRegistro; this.usuarioRegistro =
	 * usuarioRegistro; this.fechaUltmodificacion = fechaUltmodificacion;
	 * this.usuarioUltmodificacion = usuarioUltmodificacion; this.fechaPago =
	 * fechaPago; this.fechaEnvSer = fechaEnvSer; this.fechaDocPag =
	 * fechaDocPag; }
	 */

	/**
	 * Method 'getIdPagoExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdPagoExpediente() {
		return this.idPagoExpediente;
	}

	/**
	 * Method 'setIdPagoExpediente'.
	 *
	 * @param idPagoExpediente
	 *            Integer
	 * @return
	 */

	public void setIdPagoExpediente(Integer idPagoExpediente) {
		this.idPagoExpediente = idPagoExpediente;
	}

	/**
	 * @return the expediente
	 */
	/*
	 * public Expedientes getExpediente() { return expediente; }
	 */

	/**
	 * @param expediente
	 *            the expediente to set
	 */
	/*
	 * public void setExpediente(Expedientes expediente) { this.expediente =
	 * expediente; }
	 */

	/**
	 * Method 'getIdExpediente'.
	 *
	 * @return Integer
	 */

	public Integer getIdExpediente() {
		return this.idExpediente;
	}

	/**
	 * Method 'setIdExpediente'.
	 *
	 * @param idExpediente
	 *            Integer
	 * @return
	 */

	public void setIdExpediente(Integer idExpediente) {
		this.idExpediente = idExpediente;
	}

	/**
	 * Method 'getNumeroPago'.
	 *
	 * @return Long
	 */

	public Long getNumeroPago() {
		return this.numeroPago;
	}

	/**
	 * Method 'setNumeroPago'.
	 *
	 * @param numeroPago
	 *            Long
	 * @return
	 */

	public void setNumeroPago(Long numeroPago) {
		this.numeroPago = numeroPago;
	}

	/**
	 * Method 'getPorcentajePago'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getPorcentajePago() {
		return this.porcentajePago;
	}

	/**
	 * Method 'getPorcentajePagoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getPorcentajePagoMask() {
		return UtilDate.formatearMiles(porcentajePago);
	}

	/**
	 * Method 'setPorcentajePago'.
	 *
	 * @param porcentajePago
	 *            BigDecimal
	 * @return
	 */

	public void setPorcentajePago(BigDecimal porcentajePago) {
		this.porcentajePago = porcentajePago;
	}

	/**
	 * Method 'getImportePago'.
	 *
	 * @return BigDecimal
	 */

	public BigDecimal getImportePago() {
		return this.importePago;
	}

	/**
	 * Method 'getImportePagoMask'.
	 *
	 * @return BigDecimal
	 */

	public String getImportePagoMask() {
		return UtilDate.formatearMiles(importePago);

	}

	/**
	 * Method 'setImportePago'.
	 *
	 * @param importePago
	 *            BigDecimal
	 * @return
	 */

	public void setImportePago(BigDecimal importePago) {
		this.importePago = importePago;
	}

	/**
	 * Method 'getAnyoPresupuestario'.
	 *
	 * @return Long
	 */

	public Long getAnyoPresupuestario() {
		return this.anyoPresupuestario;
	}

	/**
	 * Method 'setAnyoPresupuestario'.
	 *
	 * @param anyoPresupuestario
	 *            Long
	 * @return
	 */

	public void setAnyoPresupuestario(Long anyoPresupuestario) {
		this.anyoPresupuestario = anyoPresupuestario;
	}

	/**
	 * Method 'getObservaciones'.
	 *
	 * @return String
	 */

	public String getObservaciones() {
		return this.observaciones;
	}

	/**
	 * Method 'setObservaciones'.
	 *
	 * @param observaciones
	 *            String
	 * @return
	 */

	public void setObservaciones(String observaciones) {
		this.observaciones = observaciones;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getFechaUltmodificacion'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaUltmodificacion() {
		return this.fechaUltmodificacion;
	}

	/**
	 * Method 'setFechaUltmodificacion'.
	 *
	 * @param fechaUltmodificacion
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaUltmodificacion(Date fechaUltmodificacion) {
		this.fechaUltmodificacion = fechaUltmodificacion;
	}

	/**
	 * Method 'getUsuarioUltmodificacion'.
	 *
	 * @return String
	 */

	public String getUsuarioUltmodificacion() {
		return this.usuarioUltmodificacion;
	}

	/**
	 * Method 'setUsuarioUltmodificacion'.
	 *
	 * @param usuarioUltmodificacion
	 *            String
	 * @return
	 */

	public void setUsuarioUltmodificacion(String usuarioUltmodificacion) {
		this.usuarioUltmodificacion = usuarioUltmodificacion;
	}

	/**
	 * Method 'getFechaPago'.
	 * 
	 * 
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaPago() {
		return fechaPago;
	}

	/**
	 * Method 'setFechaPago'.
	 * 
	 * @param fechaPago
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaPago(Date fechaPago) {
		this.fechaPago = fechaPago;
	}

	/**
	 * Method 'getFechaEnvSer'
	 * 
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaEnvSer() {
		return fechaEnvSer;
	}

	/**
	 * Method 'setFechaEnvSer'
	 * 
	 * @param fechaEnvSer
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaEnvSer(Date fechaEnvSer) {
		this.fechaEnvSer = fechaEnvSer;
	}

	/**
	 * Method 'getFechadocPag'
	 * 
	 * @return java.util.Date
	 */
	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaDocPag() {
		return fechaDocPag;
	}

	/**
	 * Method 'setFechaDocPag'
	 * 
	 * @param fechaDocPag
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaDocPag(Date fechaDocPag) {
		this.fechaDocPag = fechaDocPag;
	}

	/**
	 * @return the fechaPagoStr
	 */
	public String getFechaPagoStr() {
		return fechaPagoStr;
	}

	/**
	 * @param fechaPagoStr
	 *            the fechaPagoStr to set
	 */
	public void setFechaPagoStr(String fechaPagoStr) {
		this.fechaPagoStr = fechaPagoStr;
	}

	/**
	 * @return the fechaEnvSerStr
	 */
	public String getFechaEnvSerStr() {
		return fechaEnvSerStr;
	}

	/**
	 * @param fechaEnvSerStr
	 *            the fechaEnvSerStr to set
	 */
	public void setFechaEnvSerStr(String fechaEnvSerStr) {
		this.fechaEnvSerStr = fechaEnvSerStr;
	}

	/**
	 * @return the fechaDocPagStr
	 */
	public String getFechaDocPagStr() {
		return fechaDocPagStr;
	}

	/**
	 * @param fechaDocPagStr
	 *            the fechaDocPagStr to set
	 */
	public void setFechaDocPagStr(String fechaDocPagStr) {
		this.fechaDocPagStr = fechaDocPagStr;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idPagoExpediente: ").append(this.idPagoExpediente).append(" ]");
		result.append(", [ idExpediente: ").append(this.idExpediente).append(" ]");
		result.append(", [ numeroPago: ").append(this.numeroPago).append(" ]");
		result.append(", [ porcentajePago: ").append(this.porcentajePago).append(" ]");
		result.append(", [ importePago: ").append(this.importePago).append(" ]");
		result.append(", [ anyoPresupuestario: ").append(this.anyoPresupuestario).append(" ]");
		result.append(", [ observaciones: ").append(this.observaciones).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append(", [ fechaUltmodificacion: ").append(this.fechaUltmodificacion).append(" ]");
		result.append(", [ usuarioUltmodificacion: ").append(this.usuarioUltmodificacion).append(" ]");
		result.append(", [ fechaPago: ").append(this.fechaPago).append(" ]");
		result.append(", [ fechaEnvSer: ").append(this.fechaEnvSer).append(" ]");
		result.append(", [ fechaDocPag: ").append(this.fechaDocPag).append(" ]");
		result.append("}");
		return result.toString();
	}

}
